;    ,     
;  
;********************************************************************
;F_OSC			EQU	.12000		;     ( 12 )
F_OSC			EQU	.14318		;     (  . )
;******************************************************************** 
;TMR1_CONST		EQU	(F_OSC/4)	;     (1 )
T1CON_CONST		EQU	B'00000001'	; TMR1-  1:1; : F_OSC/4;  .
TMR1_CONST		EQU	(.65536-(F_OSC/4)+.15)	;    1 
								;      
CCP1CON_CONST	EQU	B'00001100'	; 1    . 2  
CCP2CON_CONST	EQU	B'00001100'	; 2    . 2  
T2CON_CONST		EQU	B'00000101'	; TMR2-  1:4; : F_OSC/4;  .
PR2_CONST		EQU	0xFF		;    2

ADCON1_CONST 	EQU	B'10000011'	; AN0-AN2,AN4-> Ain, AN3=+Vref, . .
ADCON0_CONST 	EQU	B'10000001'	; ., Tad=32Tosc
ANSEL_OFF		EQU	B'00000000'	; .  RA to digital I/O
ANSELH_OFF		EQU	B'00000000'	; . RB to digital I/O

INTCON_CONST 	EQU	B'11100000'	;   
OPTION_R_CONST	EQU	B'01100000'	; RB . . ,   . ,
								; .   TMR0,  TMR0 1:1 

	CBLOCK 0x20
;     EEPROM  
CLOCK_CHAS				;   
CLOCK_MIND				;    
CLOCK_MIN				;    
CLOCK_SEKD				;    
CLOCK_SEK				;    
CHAR_COUNT 				;     ( 100 )

ADC_AKK		:8			;    -
SUMMA		:8			;    .. 
PWM1		:2			;    1 ()
PWM2		:2			;    2 ()

ADC_TMPH				;    (16)
ADC_TMPL				; 

TIME_0					;    (1)
TIME_01_S				;    0,1
TIME_SET				;     
TIME_MS					;     
POZ_X					;    
POZ_Y					;    Y
LONG_X					;  
COUNTER					;  
TEMP0					;     
TEMP1					;  
TEMP2					;
RESULT0					;  (  Hex_dec)
RESULT1					; 
RESULT2					; 	 
RESULT3					;  
RESULT4					;   
TX_DATA
LOC_SIMVOL				;       

REG_BEEP				;   (   1)
ENCODE_DATA				;    (/)
ENCODE_MODE				;   (  )
ENCODE_STEP	:2			;  
TMP_ENCOD0
TMP_ENCOD1
;	ENDC
;	CBLOCK 0x70
W_TEMP					;     W 
STATUS_TMP				;     STATUS
PCLATH_TMP				;     PCLATH
FLAGS1					;   
FLAGS2					;   
	ENDC
;________________________________________________________________________
;				  
;________________________________________________________________________
								;  0  U 4 .
								;  1  U 3 .
								;  2  U 2 .
								;  3  U_REF +2.5V
#define	UCC_KONTROL		PORTA,4	;  4    (0) 
								;  5  U 1 .
TRISA_CONST	EQU		B'00111111'	;  5-0 
;
TRISB_CONST	EQU		B'11111111'	;  B   
								; B0 B1  
;
TRISC_CONST	EQU		B'00000000'	;  C  
;
;
								;  D0-D7    
TRISD_CONST	EQU		B'00000000'	;  D  
TRISE_CONST	EQU		B'00000011'	;  E 
;
;		   

#define TIME_OUT	FLAGS1, 0	;
#define IZM_TERMO	FLAGS1, 1	;
#define TIME_OVER	FLAGS1, 2	;
#define TIME_CHARG	FLAGS1, 3	;
#define USART_OUT	FLAGS1, 4	;     
#define TIME_100	FLAGS1, 5	;
#define TIME_DU		FLAGS1, 6	;

#define Simw_cod2	FLAGS2, 0	;   2  
#define INVERS_ON	FLAGS2, 1	;  .  
#define BUT			FLAGS2, 3	;     
#define ENCODE_PLUS	FLAGS2, 4	;     
#define ENCODE_MINUS FLAGS2, 5	;     