;*************    MPLAB IDE V. 8.63  ********************
;	      (  )
;	  44-pin_demo_Board PICkit-2
;********************************************************************
			list		p=16f887
			#include	<p16f887.inc>
			#include	<INIT_DEF.inc>	;  ,   
			errorlevel 0,-302		;     
	__CONFIG	_CONFIG1, _LVP_OFF & _FCMEN_ON & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _HS_OSC
	__CONFIG	_CONFIG2, _WRT_OFF & _BOR21V
			ORG		0x000		;  	
			nop	
			clrf	STATUS		;   0
			goto	START		;     
			ORG		0x004		;   (.   GIE)
			movwf	W_TEMP		;  
			swapf	STATUS,W	;
			clrf	STATUS		;
			movwf	STATUS_TMP	;
			movf	PCLATH, W	;    ,   2 
			movwf 	PCLATH_TMP	;
			goto	BEGIN_INT	;     
;****************************************************************************
;							 
;****************************************************************************
DECOD_ADR:	andlw	B'00001111'	;      
			addwf	PCL, F		;
			retlw	low (S_0x2)	; 0  .     -2 
			retlw	low (S_1x2)	; 1
			retlw	low (S_2x2)	; 2
			retlw	low (S_3x2)	; 3
			retlw	low (S_4x2)	; 4
			retlw	low (S_5x2)	; 5
			retlw	low (S_6x2)	; 6
			retlw	low (S_7x2)	; 7
			retlw	low (S_8x2)	; 8 
			retlw	low (S_9x2)	; 9
			retlw	low (S_TCHx2)	;  (  )
			retlw	low (S_TCHx2)	;  (  )
			retlw	low (S_TCHx2)	;  (  )
			retlw	low (S_TCHx2)	; 
			retlw	low (S_TCHx2)	; 
			retlw	low (S_2TCHKx2)	;  
;____________________________________
ENCODE_DECOD:						;   
			addwf	PCL, F			;
			goto	INT_OUT			; 0000	 
			goto	ENCODE_INCR		; 0001	+ENCODE_STEP
			goto	ENCODE_DECR		; 0010	-ENCODE_STEP
			goto	INT_OUT			; 0011	  ()
			goto	ENCODE_DECR		; 0100	-ENCODE_STEP
			goto	INT_OUT			; 0101	 
			goto	INT_OUT			; 0110	  ()
			goto	ENCODE_INCR		; 0111	+ENCODE_STEP
			goto	ENCODE_INCR		; 1000	+ENCODE_STEP
			goto	INT_OUT			; 1001	  ()
			goto	INT_OUT			; 1010	 
			goto	ENCODE_DECR		; 1011	-ENCODE_STEP
			goto	INT_OUT			; 1100	  ()
			goto	ENCODE_DECR		; 1101	-ENCODE_STEP
			goto	ENCODE_INCR		; 1110	+ENCODE_STEP
			goto	INT_OUT			; 1111	 
;===========================================================================
;			      ( 0 )
;===========================================================================			
TXT_COD:	movwf	PCL				
TXT_CHARG	RETLW 	''		
			RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	0
TXT_CHRG_ON	RETLW 	''
			RETLW 	''	
			RETLW 	''	
			RETLW 	'.'	
			RETLW 	0
TXT_CHRG_OFF
			RETLW 	''
			RETLW 	''
			RETLW 	''	
			RETLW 	''	
			RETLW 	'.'	
			RETLW 	0
TXT_MODE	RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''
			RETLW 	0
TXT_AKKUM	RETLW 	'A'	
			RETLW 	'K'	
			RETLW 	'K'	
			RETLW 	''	
			RETLW 	'M'	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''
			RETLW 	'T'	
			RETLW 	'O'	
			RETLW 	'P'	
			RETLW 	0
TXT_TRENIR	RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''	
			RETLW 	''
			RETLW 	''	
			RETLW 	''	
			RETLW 	0
TXT_EMK		RETLW 	.191	;  ( : 55 / )	
			RETLW 	''	
			RETLW 	''	
			RETLW 	':'	
			RETLW 	' '	
			RETLW 	'5'	
			RETLW 	'5'	
			RETLW 	' '	
			RETLW 	'A'	
			RETLW 	'/'	
			RETLW 	''
			RETLW 	0
TXT_TIME	RETLW 	''		;
			RETLW 	'e'	
			RETLW 	''
			RETLW 	''
			RETLW 	''	
			RETLW 	'.'
			RETLW 	' '	
			RETLW 	' '
			RETLW 	''	
			RETLW 	'p'	
			RETLW 	'e'	
			RETLW 	''	
			RETLW 	''	
			RETLW 	0
TXT_NAPR	RETLW 	'H'		;
			RETLW 	'a'	
			RETLW 	''	
			RETLW 	'p'
			RETLW 	':'	
			RETLW 	0
TXT_TOK		RETLW 	'T'		;
			RETLW 	'o'	
			RETLW 	''	
			RETLW 	':'	
			RETLW 	0
;===========================================================================

			RETLW 	0xa		;  
			RETLW 	0xd		;  
			RETLW 	0
;===========================================================================
;


;##########################################################################
BEGIN_INT:			;     1
;##########################################################################
			movlw	high(TMR1_CONST) ; TMR1     1 
			movwf	TMR1H			;  .  
			movlw	low(TMR1_CONST)	
			movwf	TMR1L			;  .  
			bcf		INTCON,2		;     
			clrf	PIR1			;   
			movlw	.1				;   = 1
			movwf	ENCODE_STEP		; (    )
			clrf	ENCODE_STEP+1	;

			incf	TIME_MS,F		;  TIME_MS  1
			btfsc	STATUS, Z		;    0
			bsf		TIME_OUT		;     
			movf 	TIME_MS, W		;

			subwf	TIME_SET, W		;      
			btfsc	STATUS, Z		;      0
			bsf		TIME_OUT		;       
			incf	TIME_0,F		;  TIME_0  1
			movlw	.100			;   100m 
			subwf	TIME_0,W		;
			btfss	STATUS,Z		;
			goto	LOC_INT1		;    100
			clrf	TIME_0			;
			incf	TIME_01_S,F		;
			movlw	.10				;   
			subwf	TIME_01_S,W		;
			btfss	STATUS,Z		;
			goto	LOC_INT1		;
			clrf	TIME_01_S		;
			incf	CLOCK_SEK,F		;    
			incf	CHAR_COUNT,F	;    /
			movlw	.10				;   10 
			subwf	CLOCK_SEK,W		;
			btfss	STATUS,Z		;
			goto	LOC_INT1		;
			bsf		IZM_TERMO		;    .   10
			clrf	CLOCK_SEK		;   
			incf	CLOCK_SEKD,F
			movlw	.6				;   60
			subwf	CLOCK_SEKD,W
			btfss	STATUS,Z		;
			goto	LOC_INT1		;
			clrf	CLOCK_SEKD		;
			incf	CLOCK_MIN,F		;  
			movlw	.10				;   10M 
			subwf	CLOCK_MIN,W		;
			btfss	STATUS,Z		;
			goto	LOC_INT1		;
			bsf		TIME_OVER		; .     
			clrf	CLOCK_MIN		;
			incf	CLOCK_MIND,F	;   
			movlw	.6				;   
			subwf	CLOCK_MIND,W
			btfss	STATUS,Z	
			goto	LOC_INT1	
			clrf	CLOCK_MIND	
			incf	CLOCK_CHAS,F
LOC_INT1:	movlw	.100			;   100 
			subwf	CHAR_COUNT,W
			btfss	STATUS,Z		; ,  CHAR_COUNT = 100
			goto	LOC_INT2		;      
			clrf	CHAR_COUNT		;  100:  CHAR_COUNT,
			bsf		TIME_CHARG		;     ,
;			bsf		USART_OUT		;      .
			btfss	TIME_100		; ,    
			goto	$+4				;    
			bcf		TIME_100		;      200 
			bsf		TIME_DU			;     dU
			goto	INT_OUT			;
			bsf		TIME_100		; (   100 )
LOC_INT2:
;	btfss	KN1				; ,     
;	bcf		BUT				;  
;	btfss	KN2				; ,     
;	bsf		BUT				;  
;	movf	REG_BEEP,W		;        1
;	btfsc	STATUS,Z		; ,   0   
;	goto	ENCODER_DAT		;  
;	decf	REG_BEEP,F		;    500 
;	bsf		PORT_BEEP		; 
;	btfss	REG_BEEP,0		;      
;	bcf		PORT_BEEP		;
ENCODER_DAT:						;     
			bcf		STATUS,C		;
			rlf		ENCODE_DATA, F	;     2 
			rlf		ENCODE_DATA, F	;
			movf	PORTB,W			;   
			andlw	B'00000011'		;
			iorwf	ENCODE_DATA, W	;      
			andlw	B'00001111'		;
			movwf	ENCODE_DATA		;    
			goto	ENCODE_DECOD	;   
INT_OUT:							;  
			movf	PCLATH_TMP, W	;  
			movwf	PCLATH		 	;
			swapf	STATUS_TMP,W 	;
			movwf	STATUS			;
			swapf	W_TEMP,F		;
			swapf	W_TEMP,W 		;
 			retfie					;   
;--------------------------------------------------------------------
ENCODE_DECR:						;  , 
			btfss	BUT				; ,   
			goto	DEC_PWM1		;   
			goto	DEC_PWM2		;  
ENCODE_INCR:						;  , 
			btfss	BUT				; ,   
			goto	INC_PWM1		;   
			goto	INC_PWM2		;  
DEC_PWM1:							;   1
			movf	PWM1+.1, W		;   0 . 
			btfss	STATUS, Z		; ,   0
			goto	$+5				;   
			movf	PWM1, W			;   0 . 
			btfss	STATUS, Z		; ,   0
			goto	$+2				;   
			goto	INT_OUT			;      =0
			movlw	.1
			subwf	PWM1, F			;  1  PWM1
			btfsc	STATUS, C		; ,   
			goto	PWM_ACTIVAT		;    
			subwf	PWM1+.1, F		;  1  PWM1H
			goto	PWM_ACTIVAT		;    
DEC_PWM2:							;   2
			movf	PWM2+.1, W		;   0 . 
			btfss	STATUS, Z		; ,   0
			goto	$+5				;   
			movf	PWM2, W			;   0 . 
			btfss	STATUS, Z		; ,   0
			goto	$+2				;   
			goto	INT_OUT			;      =0
			movlw	.1
			subwf	PWM2, F			;  1  PWM2
			btfsc	STATUS, C		; ,   
			goto	PWM_ACTIVAT		;    
			subwf	PWM2+.1, F		;  1  PWM2H
			goto	PWM_ACTIVAT		;    
INC_PWM1:							;   1
			incf	PWM1, F			;
			btfsc	STATUS,Z		; ,   
			incf	PWM1+.1, F		;
			btfss	PWM1+.1, 2		;     
			goto	PWM_ACTIVAT		;     
			goto	DEC_PWM1		;    1
INC_PWM2:							;   2
			incf	PWM2, F			;
			btfsc	STATUS,Z		; ,   
			incf	PWM2+.1, F		;
			btfss	PWM2+.1, 2		;     
			goto	PWM_ACTIVAT		;     
			goto	DEC_PWM2		;    1
;____________________________
PWM_ACTIVAT:						;     
			bcf		CCP1CON, 4		;  .  . 
			bcf		CCP1CON, 5		;
			btfsc	PWM1, 0			;     = 0
			bsf		CCP1CON, 4		;    4
			btfsc	PWM1, 1			;   1  = 0
			bsf		CCP1CON, 5		;    5
			rrf		PWM1+.1, W		;  .     TEMP1
			movwf	TMP_ENCOD1		;
			rrf		PWM1, W			;  .     TEMP0
			movwf	TMP_ENCOD0		;
			rrf		TMP_ENCOD1, F	;    .  ( ,    )
			rrf		TMP_ENCOD0, W	;    . ,   
			movwf	CCPR1L			;    
			bcf		CCP2CON, 4		;       
			bcf		CCP2CON, 5		;
			btfsc	PWM2, 0			;
			bsf		CCP2CON, 4		;
			btfsc	PWM2, 1			;
			bsf		CCP2CON, 5		;
			rrf		PWM2+.1, W		;
			movwf	TMP_ENCOD1		;
			rrf		PWM2, W			;
			movwf	TMP_ENCOD0		;
			rrf		TMP_ENCOD1, F	;
			rrf		TMP_ENCOD0, W	;
			movwf	CCPR2L			;
;_____
			movf 	ENCODE_DATA, W	;
			movwf 	PORTD			;        
			goto	INT_OUT			;  
;###################################################################
;###################################################################
;###################################################################
;							                 
;###################################################################
START:		movlw	020h			;    
			movwf	FSR				;     . 
MEM_LOP:							;  
			clrf	INDF			;    .  FSR
			incf	FSR,F			;  ...
			movlw	RESULT4			;    
			addlw	0x01			;   1    W
			xorwf	FSR,W			;  ?
			btfss	STATUS,Z		; ,   (Z=1) 
			goto	MEM_LOP			;  -   . 
			call	DEV_INIT		;   
			CALL	LCD_init	 	;  	
			call	CLR_LCD
;###################################################################
MAIN:								;   
;###################################################################
			clrf	STATUS			;  0

;    
;       
;     

			clrf	RESULT0			;     
			clrf	POZ_Y			;
			clrf	POZ_X			;
			call	UST_POZ_XY		;
			movf	RESULT0,W		;
			call	PRINT_DIG		;
			call	Cherta			;  
			incf	RESULT0,F		;
			incf	POZ_Y, F		;
			movlw	.8				;
			subwf	POZ_Y, W		;
 			btfss	STATUS, Z		;
			goto	$-.10			;  

;   
;			bsf		INVERS_ON
			movlw	.10
			movwf 	POZ_X
			movlw	.0
			movwf 	POZ_Y
			call	UST_POZ_XY		; .  
	
			MOVLW	low (TXT_TIME-TXT_COD)	; .     		 
			MOVWF	LOC_SIMVOL		; 
			call	TXT_PRINT		;
			call	CLR_STR_END		;    .   

			movlw	.15				; .  
			movwf 	POZ_X			;
			movlw	.2				;
			movwf 	POZ_Y			;
			call	UST_POZ_XY		;
			movf	CLOCK_CHAS,W	;    
			call	PRINT_DIGx2		;    
	;		movlw	''				; 
	;		call	PRINT_SIMW		;  - 
			movlw	.15				;  	
			call	PRINT_DIGx2		;   
			movf	CLOCK_MIND,W	;  
			call	PRINT_DIGx2		;
			movf	CLOCK_MIN,W		;  
			call	PRINT_DIGx2		;
	;		movlw	''				; 
	;		call	PRINT_SIMW		;
			movlw	.15				;  	
			call	PRINT_DIGx2		;   
			movf	CLOCK_SEKD,W	;  
			call	PRINT_DIGx2		;
			movf	CLOCK_SEK,W		;  
			call	PRINT_DIGx2		;
	;		movlw	''				; 
	;		call	PRINT_SIMW		;
			call	CLR_STR_END		;    .   

			movlw	.10				;   
			movwf 	POZ_X			;
			movlw	.4				;
			movwf 	POZ_Y			;
			call	UST_POZ_XY		;

			MOVLW	low (TXT_TOK-TXT_COD) ; .     	 
			MOVWF	LOC_SIMVOL		; 
			call	TXT_PRINT		;     :
			call	PROBEL_6		; 6 
			movf	PWM1, W			; .  -1
			movwf	ADC_TMPL		;
			movf	PWM1+1, W		; .  -1
			movwf	ADC_TMPH		;
			call	CONV_HEX_DEC_ADC;   ADC_TMPH, ADC_TMPL
			call	DIG_OUT_0_000	;    . *,***

			movlw	.10				;
			movwf 	POZ_X			;
			movlw	.6				;
			movwf 	POZ_Y			;
			call	UST_POZ_XY		;  
			MOVLW	low (TXT_NAPR-TXT_COD)	;  .    		 
			MOVWF	LOC_SIMVOL		; 
			call	TXT_PRINT		;     :
			call	PROBEL_3		; 3 

			movf	PWM2, W			; . 
			movfw	PWM2			; 
			movwf	ADC_TMPL		;
			movf	PWM2+1, W		; . 
			movwf	ADC_TMPH		;
			call	CONV_HEX_DEC_ADC ;   ADC_TMPH, ADC_TMPL
			call	DIG_OUT_0_000	;     . *,***
; 	  
;
;			bsf		INVERS_ON		
;			MOVLW	low (TXT_CHARG-TXT_COD)	;  .    		 
;			MOVWF	LOC_SIMVOL		; 
;			call	TXT_PRINT		;
;			movlw	':'
;			call	PRINT_SIMW
;			call	PROBEL_3
;
;			MOVLW	low (TXT_CHRG_OFF-TXT_COD)	;  .      .		 
;			MOVWF	LOC_SIMVOL		; 
;			call	TXT_PRINT		;
;			bcf		INVERS_ON
;
;
			call	DELAY_250mS		;   
			goto	MAIN

Cherta:		movlw	.7
			movwf 	POZ_X
			call	UST_POZ_XY		; .  
			movlw	0xff
			call	OUT_SPI
			return
;####################################################################
;				  
;####################################################################
DEV_INIT:							;     
			clrf	STATUS			;  0 (  STATUS)
			clrf	PORTA			;
			clrf 	PORTB			; 
			clrf	PORTC			;
			clrf	PORTD			;
			clrf	PORTE			;
			banksel	TRISA			;  1
			movlw	TRISA_CONST		;
			movwf	TRISA			;
			movlw	TRISB_CONST		;			
			movwf	TRISB			;
			movlw	TRISC_CONST		;
			movwf	TRISC			;
			movlw	TRISD_CONST		;
			movwf	TRISD			;
			movlw	TRISE_CONST		;
			movwf	TRISE			;
			banksel	ANSEL			;
			clrf	ANSEL			; RA to digital I/O
			clrf	ANSELH			; RB to digital I/O
			bcf		OPTION_REG, 7	; RB . .  
;___________________________
;  USART

;___________________________		;  -1
			banksel	T1CON			;  0
			movlw	T1CON_CONST		;  TMR1,   1   
			movwf	T1CON			;   . . 
			movlw	high(TMR1_CONST)
			movwf	TMR1H			;  .  
			movlw	low(TMR1_CONST)
			movwf	TMR1L			;  .  
			banksel	PIE1			;  1
			bsf		PIE1, TMR1IE	;    -1
;___________________________
			movlw	ADCON1_CONST 	;  
			movwf	ADCON1			;
			clrf	STATUS			;  0
			movlw	ADCON0_CONST	;
			movwf	ADCON0			;
			movlw	INTCON_CONST	;   
			movwf	INTCON			;
;___________________________
			movlw	PR2_CONST		;  -1  -2 
			banksel	PR2	
			movwf	PR2				;   
			clrf	STATUS			;  0
			movlw	T2CON_CONST		;    TMR2  
			movwf	T2CON			;
			movlw	CCP1CON_CONST	;  1  2
			movwf	CCP1CON 		;
			movlw	CCP2CON_CONST	;
			movwf	CCP2CON			;
			return
;____________________________

	#include	<LCD_Trium.inc>		;       
;	#include	<LCD_Nokia1110i.inc>
;	#include	<LCD_Nokia3310.inc>
;___________________________________________________________________
;  


;___________________________________________________________________
;			   
;  1       TIME_MS
; ,      ,    ..
DELAY_250mS: clrf	TIME_MS			;
			movlw	.250			;   0,25 
			goto	DELAY_W			;
DELAY_25mS:	clrf	TIME_MS			;
			movlw	.25				;   0,025 
			goto	DELAY_W			;
DELAY_10mS:	clrf	TIME_MS			;
			movlw	.10				;   10 
DELAY_W:	movwf	TIME_SET		;      W   
			bcf		TIME_OUT		;
Timer:		btfss	TIME_OUT		; ,    
			goto	Timer			;    
			bcf		TIME_OUT		;
 			return					; 
;____________________________
;  -,    N 
; W=((N*F_OSC/.4000-.1)/.6)   12   512 
DELAY_250uS: movlw	((.250*F_OSC/.4000-.1)/.6)
			goto	DELAY_uS		;  250 
DELAY_16uS:	movlw	((.16*F_OSC/.4000-.1)/.6)
			goto	DELAY_uS		;  16 
DELAY_2uS:	movlw	.1				;  2 
			goto	DELAY_uS
DELAY_11uS:	movlw	((.11*F_OSC/.4000-.1)/.6)	;  11 
DELAY_uS:	nop 					; 2+1	    (  W )	
			nop 					; 1
			addlw	0xFF			; 1
			btfss 	STATUS,Z		; 1 ( 2  )
			goto	DELAY_uS		; 2 
			return					; 2  
;*************************************************************************
;  

;____________________________

;_________________________________________________________________________
;    (ADC_TMP*)     : 
; U=((ADC_TMP*5/4)-dN)/1000  dN - Uref 2.5B  2,56
; dN=ADC_TMP/32 ( 34,    32,  )
;   TEMP0 TEMP1 TEMP2    RESULT*
CONV_ADC_U:							; (  26 uS)
			movf	ADC_TMPH, W		;     
			movwf	TEMP1			;
			movf	ADC_TMPL, W		;
			movwf	TEMP0			; 
			call	DELENIE_32		;   32  
			movf	ADC_TMPL, W		;   dN 
			movwf	TEMP2			; 
			movf	TEMP1, W		;   
			movwf	ADC_TMPH		;
			movf	TEMP0, W		;
			movwf	ADC_TMPL		;
			call	MULTY_4			;   4
			movf	ADC_TMPL, W		;
			addwf	TEMP0, W		;   
			btfsc	STATUS, C		;
			incf	ADC_TMPH, F		;
			movwf	ADC_TMPL		;
			movf	TEMP1, W		;
			addwf	ADC_TMPH, F		;   ADC_TMP*5
			call	DELENIE_4		;   4   
			movf	TEMP2, W		;  dN
			subwf	ADC_TMPL, F		;  dN  ADC_TMPL
			btfss	STATUS, C		;     (=1)
			decf	ADC_TMPH, F		;   . 
;	    ,   :
;	RESULT3  , 		RESULT2   ,
;	RESULT1   ,	RESULT0 
			goto	CONV_HEX_DEC_ADC ;   
;_________________________________________________________________________
;  16-. .    ( 212uS)
;	ADC_TMPH, ADC_TMPL    (  )
;	FFh FFh = 65535    :
;	. .	| 	| 		| 	| 
;	(RESULT4)	| (RESULT3)	| (RESULT2)	| (RESULT1)	| RESULT0
CONV_HEX_DEC_W:						;    W
			movwf	ADC_TMPL		;
			clrf	ADC_TMPH		;
CONV_HEX_DEC_ADC:					;   ADC_TMPH, ADC_TMPL
			movlw	.16				;   
			movwf	COUNTER			;
			clrf	RESULT0			;   
			clrf	RESULT1			;
			clrf	RESULT2			;
			bcf		STATUS, C		;
			goto	Shift			;
Next:								; 
			movlw	RESULT0			;    RESULT0   FSR
			movwf	FSR				;
			call 	Correct			;     
			movlw	RESULT1			;    RESULT1   FSR
			movwf	FSR				;
			call 	Correct			;     
Shift:								;    
			rlf		ADC_TMPL,F		;    
			rlf		ADC_TMPH,F		;    
			rlf		RESULT0,F		;  :   
			rlf		RESULT1,F		; 					  
			rlf		RESULT2,F		; 					    
			decfsz	COUNTER,F		; ,   
			goto	Next			;  -  
			movf	RESULT2,W		;    :
			movwf	RESULT4			; ( =0)  RESULT4   
			movf	RESULT1,W		;     --> W
			movwf	RESULT2			;   RESULT2 ()
			swapf	RESULT1,W		;     --> W
			movwf	RESULT3			;  RESULT3     
			swapf	RESULT0,W		;    --> W
			movwf	RESULT1			;  RESULT1     
			movlw	B'00001111'		;     
			andwf	RESULT0,F		; : 
			andwf	RESULT1,F		;            
			andwf	RESULT2,F		;            
			andwf	RESULT3,F		;             
			andwf	RESULT4,F		;             
			return					;   
Correct: 							;  
			movlw	0x03			; 03 --> W
			addwf	INDF, W			;     03 --> W
			movwf	RESULT4			;      
			btfsc	RESULT4,3		; ,   .  < 8
			movwf	INDF			;      
			movlw	0x30			; 30 --> W
			addwf	INDF, W			;     
			movwf	RESULT4			;   
			btfsc	RESULT4,7		;    <80,    W  <50
			movwf	INDF			;   ,     
			retlw	.0				;   
;___________________________________________________________________________
MULTY_4:							;   4
			movlw	.2				;
			movwf	COUNTER			;
			goto	MULTY_LOC
MULTY_16:							;   16
			movlw	.4				;
			movwf	COUNTER			;
MULTY_LOC:
			bcf		STATUS, C		;
			rlf		ADC_TMPL, F		;
			rlf		ADC_TMPH, F		;
			decfsz	COUNTER, F		;
			goto	MULTY_LOC		;
			return
;______________________________________________________________________ 
DELENIE_32:							;   32  
			movlw	.5				;
			movwf	COUNTER			;
			goto	DEL_LOC			;
DELENIE_8:							;   8  
			movlw	.3				;
			movwf	COUNTER			;
			goto	DEL_LOC			;
DELENIE_4:							;   4   
			movlw	.2				;
			movwf	COUNTER			;
DEL_LOC:
			bcf		STATUS, C		;
			rrf		ADC_TMPH, F		;
			rrf		ADC_TMPL, F		;
			decfsz	COUNTER, F		;     = 0  
			goto	DEL_LOC			;    
			return
;############################################################################
;			     
;############################################################################
PROBEL_6:	movlw	.6				;   6 
			goto	PROBEL_W		;
PROBEL_5:	movlw	.5				;   5 
			goto	PROBEL_W		;
PROBEL_4:	movlw	.4				;   4 
			goto	PROBEL_W		;
PROBEL_3:	movlw	.3				;   3 
PROBEL_W:	movwf	TEMP0			;   W 
			clrw					;
			call	OUT_SPI			;
			decfsz	TEMP0, F		; ,  TEMP0 = 0
			goto	$-3				;   
			return
;__________________________
TXT_PRINT:							;     ( 0 )
			MOVLW	low (TXT_COD)	;  .      .		 
			ADDWF	LOC_SIMVOL, W	;    .  (  )
			MOVWF	TEMP0			;  
			MOVLW	high (TXT_COD)
			BTFSC	STATUS, C		;        255 
			ADDLW	0x1				;   W  1
			MOVWF	PCLATH			;  PCLATH
			MOVF	TEMP0, W		;       .
			CALL	TXT_COD			;      
			ADDLW	0x00			;   
			BTFSC	STATUS, Z		; ,    
			RETURN					;      
;			MOVLW	high $
;			MOVWF	PCLATH			;  PCLATH
			call	PRINT_SIMW		;    . 
			incf 	LOC_SIMVOL, F	;  
			GOTO	TXT_PRINT		;      
;____________________________________
;   7x5          X Y 
PRINT_DIG:	addlw	0x30			;        
PRINT_SIMW:	movwf	TEMP0			;    
			movlw	.5				;     
			movwf	LONG_X			;    
TRNCM_LOC3	movlw	0x20			; (   )
			subwf	TEMP0, W		;     
			movwf	TEMP0			;     5
			clrf	TEMP1			;
			bcf		STATUS, C		;
			rlf		TEMP0, F		;
			rlf		TEMP1, F		;
			rlf		TEMP0, F		;
			rlf		TEMP1, F		;
			addwf	TEMP0, W		;   .    
			btfsc	STATUS, C		; ,   
			incf	TEMP1, F		;   .    
			banksel	EEADR			;  2
			movwf	EEADR			;  .    .   FLASH
			clrf	STATUS			;  0
			movlw	high (TABLE)	; 
			addwf	TEMP1, W		;   .  
			banksel	EEADR			;  2
			movwf	EEADRH			;  .  
			call	READ_FLASH		;       
			call	OUT_SPI			;    ( )
			decf	LONG_X, F		;
TRNCM_LOC1	call	READ_FLASH		;      
			addlw	.0				;   
			btfsc	STATUS, Z		; ,   			
			goto	TRNCM_LOC2		;   
			call	OUT_SPI			;   
			decfsz	LONG_X, F		; ,   
			goto	TRNCM_LOC1		;    
			clrw					;
TRNCM_LOC2	call	OUT_SPI			;      
			return
;____________________________________
PRINT_SIMWx2:						;    

PRINT_DIGx2:						;    
			call	DECOD_ADR		;  .    
			banksel	EEADR			;  2
			movwf	EEADR			;  .    .   FLASH
			movlw	high (TABLE2x2)
			movwf	EEADRH			;  .  
			call	READ_FLASH		;     -2
			bcf		Simw_cod2		;    2  
			movwf	LONG_X
Tx_Lop3:	movf	LONG_X, W		; LONG_X    + 2 
			movwf	TEMP0
Tx_Lop2:	call	READ_FLASH		;      -2
			call	OUT_SPI			;   
			decfsz	TEMP0, F		;       
			goto	Tx_Lop2
			clrw					;    2   	
			call	OUT_SPI			;
			clrw					;
			call	OUT_SPI			;
			btfsc	Simw_cod2		; ,    2-  
			goto	Tx_Loc4			;   
			bsf		Simw_cod2		;    2-   
			movf	LONG_X, W		;        
			addlw	.2				;
			subwf	POZ_X, F		;  LONG_X   
			decf	POZ_Y, F
			call	UST_POZ_XY		;       
			goto	Tx_Lop3			;   
Tx_Loc4:	incf	POZ_Y, F		;      
			call	UST_POZ_XY			;      
			return
;____________________________________
READ_FLASH:							;    
			banksel	EECON1			;  3
			bsf		EECON1, EEPGD	;   FLASH 
			bsf		EECON1, RD		; 
			nop						; 2  
			nop						;
			banksel	EEDATA			;  2
			incf	EEADR, F		;   1  
			btfsc	STATUS, Z		;    
			incf	EEADRH, F		;   1 .  
			movf	EEDATA, W		;    (.  )
			clrf	STATUS			;  0
			return
;___________________________________________________________________
DIG_OUT_0_000: 						;     0,000
			movf	RESULT3, W		; 
			call	PRINT_DIG		;
			movlw	'.'
			call	PRINT_SIMW		;  
DIG_OUT_000:
			movf	RESULT2, W		; 
			call	PRINT_DIG		;
DIG_OUT_00:
			movf	RESULT1, W		; 
			call	PRINT_DIG		;
			movf	RESULT0, W		; 
			call	PRINT_DIG		;
			return	
;____________________________________



;___________________________________________________________________
;
;			        


;#############################################################################
	#include	<LCD_Tabl_out.inc>	;       
;	#include	<Tabl_EEPROM.inc>	;    EEPROM 
	end								;  